;
; $Id: $
;
; Module:  extras -- description
; Created: 12-SEP-2008 15:19
; Author:  tmr

; Assertion
(setq assert (special (expr)
  (cond ( (is (eval expr) t) (list 'ASSERT-SUCCESS '=> expr) )
        ( t                  (list 'ASSERT-FAILURE '=> expr) ) )))

; List operations
(setq list$lenght (lambda (x)
  (cond ( (is x nil) 0 )
        ( (not (islist x)) (report-error 'LIST-E-IVARGS "An argument must be a list!") )
        ( t (+ 1 (list$lenght (cdr x))) ) )))

(setq list$compare (lambda (x y)
  (cond ( (&& (is x nil) (is y nil)) t )
        ( (not (= (list$lenght x) (list$lenght y))) nil )
        ( (is (car x) (car y)) (list$compare (cdr x) (cdr y)) )
        ( t nil ) )))

; Stack data structure implementation
; (<STACK> A B C D E F ...)

(setq stack$id '<STACK>)

(setq stack$create (special (ref)
  (set ref (cons stack$id nil)) ))

;(setq stack$check (lambda (s)
;  (&& (islist s)
;      (is (car s) stack$id) ) ))
;
; Since logical operators doesn't support short-eval
(setq stack$check (lambda (s)
  (cond ( (not (islist s)) nil )
        ( t (is (car s) stack$id) ) ) ))

(setq stack$fromlist (special (ref data)
  (set ref (cons stack$id (eval data))) ))

(setq stack$tolist (lambda (s)
  (cond ( (not (stack$check s)) (report-error 'STACK-E-IVARGS
                                   "An argument must be a stack!") )
        ( t (cdr s) ) ) ))

(setq stack$push (special (ref item)
  (let ( (eref (eval ref)) )
    (cond ( (not (stack$check eref)) (report-error 'STACK-E-IVARGS
                                        "An argument must be a stack!") )
          (t (set ref (cons (car eref) (cons (eval item) (cdr eref)))) ) ) ) ))

(setq stack$peek (special (ref)
  (let ( (eref (eval ref)) )
    (cond ( (not (stack$check eref)) (report-error 'STACK-E-IVARGS
                                        "An argument must be a stack!") )
          (t (car (cdr eref)) ) ) ) ))

(setq stack$pop (special (ref)
  (let ( (eref (eval ref)) )
    (cond ( (not (stack$check eref)) (report-error 'STACK-E-IVARGS
                                        "An argument must be a stack!") )
          (t (let ( (result (stack$peek eref)) )
               (set ref (cons stack$id (cdr (cdr eref)))) result ) ) ) ) ))

(setq stack$size (lambda (s) (- (list$lenght s) 1) ))

; Binary Search Tree operations
;(setq bst$create (special (ref root)
;  (set ref (list (eval root) nil nil)) ))
;
;(setq bst$getkey (lambda (ref) (car ref) ))
;
;(setq bst$getleft (lambda (ref) (car (cdr ref)) ))
;
;(setq bst$getright (lambda (ref) (car (cdr (cdr ref))) ))
;
;(setq bst$setkey (special (ref item)
;  (let ( (eref  (eval ref))
;         (eitem (eval item)) )
;       (set ref (cons eitem (cdr eref)) ) )))
;
;(setq bst$setleft (special (ref item)
;  (let ( (eref (eval ref)) )
;       (set ref (list (car eref) (eval item) (bst$getright eref)) ) )))
;
;(setq bst$setright (special (ref item)
;  (let ( (eref (eval ref)) )
;       (set ref (list (car eref) (bst$getleft eref) (eval item)) ) )))
;
;(setq bst$_add (lambda (root item)
;  (cond ( (is root nil) item )
;        ( (not (islist root)) nil )
;        ( (> (bst$getkey root) item) (bst$setleft  root (eval (bst$_add (bst$getleft  root) item))) )
;        ( (< (bst$getkey root) item) (bst$setright root (eval (bst$_add (bst$getright root) item))) ) )))
;
;(setq bst$add (special (ref item)
;  (let ( (eitem (eval item)) )
;       (cond ( (> (bst$getkey ref) eitem) (bst$setleft) )
;             ( () () ) ) )))
;
;(assert (list$compare (bst$create mytree 1) '(1 nil nil)))
;(assert (is (bst$getkey   mytree)   1))
;(assert (is (bst$getleft  mytree) nil))
;(assert (is (bst$getright mytree) nil))

; Polynom calculations
; x ... a list of coeficients
; y ... a value of unknown
(setq math$polycalc (lambda (x y)
  (let ( (poly (stack$fromlist poly x))
         (curr (stack$pop poly)) )
    (cond ( (is curr nil) 0 )
          ( t (+ (* y (exp y (stack$size poly)))
                 (math$polycalc (stack$tolist poly) y)) ) ) ) ))

; vim: fdm=syntax:fdn=3:tw=74:ts=2:syn=lisp
